/*!
 * KoliBri - The accessible HTML-Standard
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const index=require("./index-26a16cf8.js"),dev_utils=require("./dev.utils-a9a312e8.js"),events=require("./events-e348a615.js"),reuse=require("./reuse-a4c8450e.js"),controller$1=require("./controller-8a663b94.js"),prop_validators=require("./prop.validators-c61f861a.js"),a11y_tipps=require("./a11y.tipps-acf8dda9.js"),controller=require("./controller-69f2ca4d.js");require("./hide-label-94cb2a98.js"),require("./label-56c1f9e1.js"),require("./tab-index-b044abf3.js"),require("./associated.controller-6f39b321.js"),require("./index-a60d6032.js");const validateChecked=(t,e)=>{prop_validators.watchBoolean(t,"_checked",e)},validateIndeterminate=(t,e)=>{prop_validators.watchBoolean(t,"_indeterminate",e)};class InputCheckboxController extends controller.InputCheckboxRadioController{constructor(t,e,n){super(t,e,n),this.setFormAssociatedCheckboxValue=t=>{this.component._checked?this.setFormAssociatedValue(t):this.setFormAssociatedValue(null)},this.component=t}validateChecked(t){validateChecked(this.component,t),this.setFormAssociatedCheckboxValue(this.component.state._value)}validateIcon(t){this.validateIcons(t)}validateIcons(t){prop_validators.watchValidator(this.component,"_icons",(t=>"object"==typeof t&&null!==t&&(reuse.isString(t.checked,1)||reuse.isString(t.indeterminate,1)||reuse.isString(t.unchecked,1))),new Set(["InputCheckboxIcons"]),t,{hooks:{beforePatch:(t,e,n)=>{e.set("_icons",Object.assign(Object.assign({},n.state._icons),t))}}})}validateIndeterminate(t){validateIndeterminate(this.component,t)}validateType(t){a11y_tipps.devHint('The "_type" prop is deprecated. Use "_variant" instead.'),this.validateVariant(t)}validateValue(t){prop_validators.setState(this.component,"_value",t),this.setFormAssociatedCheckboxValue(this.component.state._value)}validateVariant(t){"checkbox"===t&&(a11y_tipps.devHint("[KolCheckbox] The \"_variant\" value 'checkbox' is deprecated. Use the new value 'default' instead."),t="default"),prop_validators.watchValidator(this.component,"_variant",(t=>"string"==typeof t&&("button"===t||"default"===t||"switch"===t)),new Set(["String {button, default, switch}"]),t)}componentWillLoad(){super.componentWillLoad(),this.validateChecked(this.component._checked),this.validateIcons(this.component._icons||this.component._icon),this.validateIndeterminate(this.component._indeterminate),this.validateValue(this.component._value),this.validateVariant(this.component._variant||this.component._type)}}const defaultStyleCss="/*\n * This file contains all rules for accessibility.\n */\n:host {\n\t/*\n\t * Minimum size of interactive elements.\n\t */\n\t--a11y-min-size: 44px;\n\t/*\n\t * No element should be used without a background and font color whose contrast ratio has\n\t * not been checked. By initially setting the background color to white and the font color\n\t * to black, the contrast ratio is ensured and explicit adjustment is forced.\n\t */\n\tbackground-color: white;\n\tcolor: black;\n\t/*\n\t * Verdana is an accessible font that can be used without requiring additional loading time.\n\t */\n\tfont-family: Verdana;\n}\n* {\n\t/*\n\t * This rule enables the word dividing for all texts. That is important for high zoom levels.\n\t */\n\thyphens: auto;\n\t/*\n\t * Letter spacing is required for all texts.\n\t */\n\tletter-spacing: inherit;\n\t/*\n\t * This rule enables the word dividing for all texts. That is important for high zoom levels.\n\t */\n\tword-break: break-word;\n\t/*\n\t * Word spacing is required for all texts.\n\t */\n\tword-spacing: inherit;\n}\n/*\n * All interactive elements should have a minimum size of 44px.\n */\n/* input:not([type='checkbox'], [type='radio'], [type='range']), */\n/* option, */\n/* select, */\n/* textarea, */\n[role='button'],\nbutton:not([role='link']),\nkol-input .input {\n\tmin-height: var(--a11y-min-size);\n\tmin-width: var(--a11y-min-size);\n}\n/*\n * Some interactive elements should not inherit the font-family and font-size.\n */\na,\nbutton,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\ninput,\noption,\nselect,\ntextarea {\n\t/*\n\t * All elements should inherit the font family from his parent element.\n\t */\n\tfont-family: inherit;\n\t/*\n\t * All elements should inherit the font size from his parent element.\n\t */\n\tfont-size: inherit;\n}\n\n/**\n * Sometimes we need the semantic element for accessibility reasons,\n * but we don't want to show it.\n *\n * - https://www.a11yproject.com/posts/how-to-hide-content/\n */\n.visually-hidden {\n\tclip: rect(0 0 0 0);\n\tclip-path: inset(50%);\n\theight: 1px;\n\toverflow: hidden;\n\tposition: absolute;\n\twhite-space: nowrap;\n\twidth: 1px;\n}\n\n/*\n * Dieses CSS stellt sicher, dass der Standard-Style\n * von A und Button resettet werden.\n */\n:is(a, button) {\n\tbackground-color: transparent;\n\tborder: none;\n\tmargin: 0;\n\tpadding: 0;\n\twidth: 100%; /* 100% needed for custom width from outside */\n}\n\n/*\n\t * Ensure elements with hidden attribute to be actually not visible\n\t * @see https://meowni.ca/hidden.is.a.lie.html\n\t */\n[hidden] {\n\tdisplay: none !important;\n}\n\n:host {\n\t/*\n\t * The max-width is needed to prevent the table from overflowing the\n\t * parent node, if the table is wider than the parent node.\n\t */\n\tmax-width: 100%;\n}\n* {\n\t/*\n\t * We prefer to box-sizing: border-box for all elements.\n\t */\n\tbox-sizing: border-box;\n}\n/* KolSpan is a layout component with icons in all directions and a label text in the middle. */\nkol-span-wc {\n\tdisplay: grid;\n\tplace-items: center;\n}\n/* The sub span in KolSpan is the horizontal span with icon left and right and the label text in the middle. */\nkol-span-wc > span {\n\tdisplay: flex;\n\tplace-items: center;\n}\na,\nbutton {\n\tcursor: pointer;\n}\n/* This is the text label. */\n.icon-only > kol-span-wc > span > span {\n\tdisplay: none;\n}\n.hidden {\n\tdisplay: none;\n\tvisibility: hidden;\n}\n\n.required label > span::after,\n.required legend > span::after {\n\tcontent: '*';\n}\n\n:host {\n\tdisplay: block;\n}\n\ninput,\ntextarea {\n\tcursor: text;\n}\ninput[type='checkbox'],\ninput[type='color'],\ninput[type='file'],\ninput[type='radio'],\ninput[type='range'],\nlabel,\noption,\nselect {\n\tcursor: pointer;\n}\n/* input[type='checkbox'], */\n/* input[type='radio'], */\n/* input[type='range'], */\ninput[type='color'],\ninput[type='date'],\ninput[type='datetime-local'],\ninput[type='email'],\ninput[type='file'],\ninput[type='month'],\ninput[type='number'],\ninput[type='password'],\ninput[type='search'],\ninput[type='tel'],\ninput[type='text'],\ninput[type='time'],\ninput[type='url'],\ninput[type='week'],\nselect,\nselect[multiple] option,\ntextarea {\n\tfont-size: 1rem;\n\twidth: 100%;\n}\n/* needed hack for vertical alignment */\ninput[type='file'] {\n\tpadding: calc((var(--a11y-min-size) - 1rem) / 10) 0.5em;\n}\n/* needed hack for vertical alignment */\nselect[multiple] option {\n\tpadding: calc((var(--a11y-min-size) - 1rem) / 2) 0.5em;\n}\nkol-input.disabled :is(button, input, option, select, textarea, .input-label) {\n\tcursor: not-allowed;\n\topacity: 0.5;\n}\n\nlabel {\n\tcursor: pointer;\n}\nkol-input {\n\talign-items: center;\n\tdisplay: grid;\n\tjustify-items: left;\n}\nkol-input.default,\nkol-input.switch {\n\tgrid-template-columns: auto 1fr;\n}\nkol-input .input {\n\talign-items: center;\n\tdisplay: grid;\n\torder: 1;\n}\nkol-input .input div {\n\tdisplay: inline-flex;\n}\nkol-input .input input {\n\tmargin: 0;\n}\nkol-input label {\n\torder: 2;\n}\nkol-input .hint,\nkol-input.error > kol-alert {\n\tgrid-column: span 2;\n}\nkol-input kol-alert.error {\n\torder: 3;\n}\nkol-input .hint {\n\torder: 4;\n}\n\ninput {\n\tborder-style: solid;\n\tborder-width: 2px;\n\tline-height: 24px;\n}\ninput[type='checkbox'] {\n\tappearance: none;\n\tbackground-color: #fff;\n\tcursor: pointer;\n\ttransition: 0.5s;\n}\ninput[type='checkbox'].kol-disabled:before {\n\tcursor: not-allowed;\n}\ninput[type='checkbox']:before {\n\tcontent: '';\n\tcursor: pointer;\n}\nkol-input.required .tooltip-content .span-label::after {\n\tcontent: '*';\n}\n\n.button {\n\tdisplay: grid;\n\tgrid-template-columns: var(--a11y-min-size) auto;\n\tgrid-template-areas: 'error error' 'input label' 'hint hint';\n}\n.button:focus-within {\n\t/* override global `[tabindex]:focus` style */\n\tcursor: inherit;\n\toutline-color: black;\n\toutline-style: solid;\n}\n.button > .error {\n\tgrid-area: error;\n}\n.button > label {\n\tgrid-area: label;\n}\n.button > .input {\n\tgrid-area: input;\n}\n.button > .hint {\n\tgrid-area: hint;\n}\n.button .icon {\n\tdisplay: flex;\n\talign-items: center;\n\tjustify-content: center;\n\twidth: var(--a11y-min-size);\n\theight: var(--a11y-min-size);\n}\n\n@layer kol-component {\n\t.default {\n\t\t& .checkbox-container {\n\t\t\talign-items: center;\n\t\t\tdisplay: flex;\n\t\t\theight: var(--a11y-min-size);\n\t\t\tjustify-content: center;\n\t\t\tposition: relative;\n\t\t\twidth: var(--a11y-min-size);\n\t\t}\n\n\t\t& .icon {\n\t\t\tdisplay: block;\n\t\t\tinset: auto;\n\t\t\tposition: absolute;\n\t\t\tz-index: 1;\n\t\t}\n\t\t&:not(.checked):not(.indeterminate) .icon::part(icon) {\n\t\t\tdisplay: none;\n\t\t}\n\n\t\t& .checkbox-input-element {\n\t\t\twidth: 22px;\n\t\t\theight: 22px;\n\t\t}\n\t}\n}\n\n@layer kol-component {\n\t.switch .input {\n\t\tposition: relative;\n\t}\n\t.switch input[type='checkbox'] {\n\t\tdisplay: inline-block;\n\t\theight: 1.7em;\n\t\tmin-width: 3.2em;\n\t\tposition: relative;\n\t\twidth: 3.2em;\n\t}\n\t.switch input[type='checkbox']::before {\n\t\tbackground-color: #000;\n\t\theight: 1.2em;\n\t\tleft: calc(0.25em - 2px);\n\t\ttop: calc(0.25em - 2px);\n\t\tposition: absolute;\n\t\ttransition: 0.5s;\n\t\twidth: 1.2em;\n\t}\n\t.switch input[type='checkbox']:checked::before {\n\t\ttransform: translateX(1.5em);\n\t}\n\t.switch input[type='checkbox']:indeterminate::before {\n\t\ttransform: translateX(0.75em);\n\t}\n\t.switch .icon {\n\t\tcursor: pointer;\n\t\tdisplay: flex;\n\t\talign-items: center;\n\t\tjustify-content: center;\n\t\twidth: 1.2em;\n\t\theight: 1.2em;\n\t\tposition: absolute;\n\t\tz-index: 1;\n\t\ttop: 50%;\n\t\tleft: 4px;\n\t\ttransform: translate(0, -50%);\n\t\ttransition: 0.5s;\n\t\tcolor: #000;\n\t}\n\t.switch.checked .icon {\n\t\ttransform: translate(1.5em, -50%);\n\t}\n\t.switch.indeterminate .icon {\n\t\ttransform: translate(0.75em, -50%);\n\t}\n}\n\n",KolInputCheckboxDefaultStyle0=defaultStyleCss,KolInputCheckbox=class{render(){const{ariaDescribedBy:t}=controller$1.getRenderStates(this.state),e=reuse.showExpertSlot(this.state._label);return index.h(index.Host,null,index.h("kol-input",{class:{checkbox:!0,[this.state._variant]:!0,"hide-label":!!this.state._hideLabel,checked:this.state._checked,indeterminate:this.state._indeterminate},"data-role":"button"===this.state._variant?"button":void 0,onKeyPress:"button"===this.state._variant?this.onChange:void 0,_alert:this.state._alert,_disabled:this.state._disabled,_error:this.state._error,_hideError:this.state._hideError,_hideLabel:this.state._hideLabel,_hint:this.state._hint,_id:this.state._id,_label:this.state._label,_required:this.state._required,_tooltipAlign:this._tooltipAlign,_touched:this.state._touched},index.h("span",{slot:"label"},e?index.h("slot",null):this.state._label),index.h("label",{slot:"input",class:"checkbox-container"},index.h("kol-icon",{class:"icon",_icons:this.state._indeterminate?this.state._icons.indeterminate:this.state._checked?this.state._icons.checked:this.state._icons.unchecked,_label:""}),index.h("input",Object.assign({class:"checkbox-input-element"+("button"===this.state._variant?" visually-hidden":""),ref:this.catchRef,title:"",accessKey:this.state._accessKey,"aria-describedby":t.length>0?t.join(" "):void 0,"aria-label":this.state._hideLabel&&"string"==typeof this.state._label?this.state._label:void 0,checked:this.state._checked,disabled:this.state._disabled,id:this.state._id,indeterminate:this.state._indeterminate,name:this.state._name,required:this.state._required,tabIndex:this.state._tabIndex,type:"checkbox"},this.controller.onFacade,{onChange:this.onChange,onClick:void 0})))))}constructor(t){index.registerInstance(this,t),this.catchRef=t=>{reuse.propagateFocus(this.host,t)},this.onChange=t=>{var e;this._checked=!this._checked,this._indeterminate=!1;const n=this._checked?this.state._value:null;events.tryToDispatchKoliBriEvent("change",this.host,n),this.controller.setFormAssociatedCheckboxValue(n),"function"==typeof(null===(e=this._on)||void 0===e?void 0:e.onChange)&&this._on.onChange(t,n)},this._accessKey=void 0,this._alert=!0,this._checked=!1,this._hideError=!1,this._disabled=!1,this._error=void 0,this._hideLabel=!1,this._hint="",this._icon=void 0,this._icons=void 0,this._id=void 0,this._indeterminate=void 0,this._label=void 0,this._name=void 0,this._on=void 0,this._required=!1,this._syncValueBySelector=void 0,this._tabIndex=void 0,this._tooltipAlign="top",this._touched=!1,this._type=void 0,this._value=!0,this._variant=void 0,this.state={_checked:!1,_hideError:!1,_icons:{checked:"codicon codicon-check",indeterminate:"codicon codicon-remove",unchecked:"codicon codicon-add"},_id:`id-${dev_utils.nonce()}`,_indeterminate:!1,_label:"…",_value:!0,_variant:"default"},this.controller=new InputCheckboxController(this,"input-checkbox",this.host)}validateAccessKey(t){this.controller.validateAccessKey(t)}validateAlert(t){this.controller.validateAlert(t)}validateChecked(t){this.controller.validateChecked(t)}validateDisabled(t){this.controller.validateDisabled(t)}validateError(t){this.controller.validateError(t)}validateHideError(t){this.controller.validateHideError(t)}validateHideLabel(t){this.controller.validateHideLabel(t)}validateHint(t){this.controller.validateHint(t)}validateIcon(t){this.validateIcons(t)}validateIcons(t){this.controller.validateIcons(t)}validateId(t){this.controller.validateId(t)}validateIndeterminate(t){this.controller.validateIndeterminate(t)}validateLabel(t){this.controller.validateLabel(t)}validateName(t){this.controller.validateName(t)}validateOn(t){this.controller.validateOn(t)}validateRequired(t){this.controller.validateRequired(t)}validateSyncValueBySelector(t){this.controller.validateSyncValueBySelector(t)}validateTabIndex(t){this.controller.validateTabIndex(t)}validateTouched(t){this.controller.validateTouched(t)}validateType(t){this.controller.validateType(t)}validateValue(t){this.controller.validateValue(t)}validateVariant(t){this.controller.validateVariant(t)}componentWillLoad(){this._alert=!0===this._alert,this._touched=!0===this._touched,this.controller.componentWillLoad()}get host(){return index.getElement(this)}static get watchers(){return{_accessKey:["validateAccessKey"],_alert:["validateAlert"],_checked:["validateChecked"],_disabled:["validateDisabled"],_error:["validateError"],_hideError:["validateHideError"],_hideLabel:["validateHideLabel"],_hint:["validateHint"],_icon:["validateIcon"],_icons:["validateIcons"],_id:["validateId"],_indeterminate:["validateIndeterminate"],_label:["validateLabel"],_name:["validateName"],_on:["validateOn"],_required:["validateRequired"],_syncValueBySelector:["validateSyncValueBySelector"],_tabIndex:["validateTabIndex"],_touched:["validateTouched"],_type:["validateType"],_value:["validateValue"],_variant:["validateVariant"]}}};KolInputCheckbox.style={default:KolInputCheckboxDefaultStyle0},exports.kol_input_checkbox=KolInputCheckbox;