/*!
 * KoliBri - The accessible HTML-Standard
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const index=require("./index-26a16cf8.js"),i18n=require("./i18n-9412d850.js"),label=require("./label-56c1f9e1.js"),a11y_tipps=require("./a11y.tipps-acf8dda9.js"),prop_validators=require("./prop.validators-c61f861a.js");require("./index-9549bac5.js"),require("./index-a60d6032.js"),require("./dev.utils-a9a312e8.js"),require("./reuse-a4c8450e.js");const defaultStyleCss="/*\n * This file contains all rules for accessibility.\n */\n:host {\n\t/*\n\t * Minimum size of interactive elements.\n\t */\n\t--a11y-min-size: 44px;\n\t/*\n\t * No element should be used without a background and font color whose contrast ratio has\n\t * not been checked. By initially setting the background color to white and the font color\n\t * to black, the contrast ratio is ensured and explicit adjustment is forced.\n\t */\n\tbackground-color: white;\n\tcolor: black;\n\t/*\n\t * Verdana is an accessible font that can be used without requiring additional loading time.\n\t */\n\tfont-family: Verdana;\n}\n* {\n\t/*\n\t * This rule enables the word dividing for all texts. That is important for high zoom levels.\n\t */\n\thyphens: auto;\n\t/*\n\t * Letter spacing is required for all texts.\n\t */\n\tletter-spacing: inherit;\n\t/*\n\t * This rule enables the word dividing for all texts. That is important for high zoom levels.\n\t */\n\tword-break: break-word;\n\t/*\n\t * Word spacing is required for all texts.\n\t */\n\tword-spacing: inherit;\n}\n/*\n * All interactive elements should have a minimum size of 44px.\n */\n/* input:not([type='checkbox'], [type='radio'], [type='range']), */\n/* option, */\n/* select, */\n/* textarea, */\n[role='button'],\nbutton:not([role='link']),\nkol-input .input {\n\tmin-height: var(--a11y-min-size);\n\tmin-width: var(--a11y-min-size);\n}\n/*\n * Some interactive elements should not inherit the font-family and font-size.\n */\na,\nbutton,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\ninput,\noption,\nselect,\ntextarea {\n\t/*\n\t * All elements should inherit the font family from his parent element.\n\t */\n\tfont-family: inherit;\n\t/*\n\t * All elements should inherit the font size from his parent element.\n\t */\n\tfont-size: inherit;\n}\n\n/**\n * Sometimes we need the semantic element for accessibility reasons,\n * but we don't want to show it.\n *\n * - https://www.a11yproject.com/posts/how-to-hide-content/\n */\n.visually-hidden {\n\tclip: rect(0 0 0 0);\n\tclip-path: inset(50%);\n\theight: 1px;\n\toverflow: hidden;\n\tposition: absolute;\n\twhite-space: nowrap;\n\twidth: 1px;\n}\n\n/*\n * Dieses CSS stellt sicher, dass der Standard-Style\n * von A und Button resettet werden.\n */\n:is(a, button) {\n\tbackground-color: transparent;\n\tborder: none;\n\tmargin: 0;\n\tpadding: 0;\n\twidth: 100%; /* 100% needed for custom width from outside */\n}\n\n/*\n\t * Ensure elements with hidden attribute to be actually not visible\n\t * @see https://meowni.ca/hidden.is.a.lie.html\n\t */\n[hidden] {\n\tdisplay: none !important;\n}\n\n:host {\n\t/*\n\t * The max-width is needed to prevent the table from overflowing the\n\t * parent node, if the table is wider than the parent node.\n\t */\n\tmax-width: 100%;\n}\n* {\n\t/*\n\t * We prefer to box-sizing: border-box for all elements.\n\t */\n\tbox-sizing: border-box;\n}\n/* KolSpan is a layout component with icons in all directions and a label text in the middle. */\nkol-span-wc {\n\tdisplay: grid;\n\tplace-items: center;\n}\n/* The sub span in KolSpan is the horizontal span with icon left and right and the label text in the middle. */\nkol-span-wc > span {\n\tdisplay: flex;\n\tplace-items: center;\n}\na,\nbutton {\n\tcursor: pointer;\n}\n/* This is the text label. */\n.icon-only > kol-span-wc > span > span {\n\tdisplay: none;\n}\n.hidden {\n\tdisplay: none;\n\tvisibility: hidden;\n}\n\n:host {\n\tdisplay: block;\n}\n\n:host {\n\tdisplay: grid;\n}\n:host > div.table {\n\tmax-width: 100%;\n\torder: 1;\n\toverflow-x: auto;\n\toverflow-y: hidden;\n}\n:host > div.table table {\n\twidth: 100%;\n}\ncaption {\n\ttext-align: start;\n\n\t&:focus {\n\t\toutline: 0 !important;\n\t}\n}\n.table:has(caption:focus) {\n\t/* @see https://remysharp.com/til/css/focus-ring-default-styles */\n\toutline: 5px auto Highlight;\n\toutline: 5px auto -webkit-focus-ring-color;\n\toutline-offset: 2px;\n}\nth > div {\n\tdisplay: grid;\n\tgrid-template-columns: 1fr auto;\n\tplace-items: center;\n}\n.table-sort-button .button {\n\tcolor: inherit;\n}\nth.align-left {\n\ttext-align: left;\n\t& .table-sort-button .button-inner {\n\t\tjustify-items: start;\n\t}\n}\nth.align-center {\n\ttext-align: center;\n\t& .table-sort-button .button-inner {\n\t\tjustify-items: center;\n\t}\n}\nth.align-right {\n\ttext-align: right;\n\t& .table-sort-button .button-inner {\n\t\tjustify-items: end;\n\t}\n}\ndiv.pagination {\n\torder: 2;\n}\ndiv.pagination,\ndiv.pagination > div:last-child {\n\tdisplay: grid;\n\tplace-items: center;\n}\n@media (min-width: 1024px) {\n\tdiv.pagination,\n\tdiv.pagination > div:last-child {\n\t\tgrid-auto-flow: column;\n\t}\n\tdiv.pagination kol-pagination {\n\t\tdisplay: flex;\n\t}\n}\n",KolTableDefaultStyle0=defaultStyleCss,PAGINATION_OPTIONS=[10,20,50,100],CELL_REFS=new Map,paginationValidator=t=>!0===t||""===t||"object"==typeof t&&null!==t,KolTable=class{constructor(t){index.registerInstance(this,t),this.horizontal=!0,this.sortDirections=new Map,this.showPagination=!1,this.pageStartSlice=0,this.pageEndSlice=10,this.disableSort=!1,this.sortedColumnHead={label:"",key:"",sortDirection:"NOS"},this.setSortDirection=(t,e)=>{this.sortDirections.clear(),this.sortDirections.set(t,e),this.sortFunction=t},this.handlePagination={onClick:(t,e)=>{var i;"function"==typeof(null===(i=this.state._pagination._on)||void 0===i?void 0:i.onClick)&&this.state._pagination._on.onClick(t,e),prop_validators.setState(this,"_pagination",Object.assign(Object.assign({},this.state._pagination),{_page:e}))},onChangePage:(t,e)=>{var i;"function"==typeof(null===(i=this.state._pagination._on)||void 0===i?void 0:i.onChangePage)&&this.state._pagination._on.onChangePage(t,e),prop_validators.setState(this,"_pagination",Object.assign(Object.assign({},this.state._pagination),{_page:e}))},onChangePageSize:(t,e)=>{var i;"function"==typeof(null===(i=this.state._pagination._on)||void 0===i?void 0:i.onChangePageSize)&&this.state._pagination._on.onChangePageSize(t,e),prop_validators.setState(this,"_pagination",Object.assign(Object.assign({},this.state._pagination),{_pageSize:e})),prop_validators.setState(this,"_pageSize",e)}},this.updateSortedData=(t=this.sortedColumnHead)=>{let e=this.state._data;if("function"==typeof this.sortFunction)switch(this.sortDirections.get(this.sortFunction)){case"ASC":e=this.sortFunction([...this.state._data]),this.sortedColumnHead={label:t.label,key:t.key,sortDirection:"ASC"};break;case"DESC":e=this.sortFunction([...this.state._data]).reverse(),this.sortedColumnHead={label:t.label,key:t.key,sortDirection:"DESC"};break;default:e=[...this.state._data],this.sortedColumnHead={label:"",key:"",sortDirection:"NOS"}}prop_validators.setState(this,"_sortedData",e)},this.renderTableRow=(t,e)=>index.h("tr",{key:`tbody-${e}`},t.map(((t,i)=>this.renderTableCell(t,e,i)))),this.renderTableCell=(t,e,i)=>{if(!1===t.asTd){const n=t;let a,o="codicon codicon-fold";if(!this.disableSort&&n.key===this.sortedColumnHead.key)switch(this.sortedColumnHead.sortDirection){case"ASC":o="codicon codicon-chevron-up",a="ascending";break;case"DESC":o="codicon codicon-chevron-down",a="descending"}return index.h("th",{key:`tbody-${e}-${i}-${n.label}`,scope:"number"==typeof n.rowSpan&&n.rowSpan>1?"rowgroup":"row",colSpan:n.colSpan,rowSpan:n.rowSpan,style:{textAlign:n.textAlign,width:n.width},"aria-sort":a,"data-sort":`sort-${this.sortDirections.get(n.sort)}`},index.h("div",{class:"w-full flex gap-1 items-center"},index.h("div",{class:{"w-full":!0,[n.textAlign]:"string"==typeof n.textAlign&&n.textAlign.length>0},style:{textAlign:n.textAlign}},n.label),!this.disableSort&&"function"==typeof n.sort&&index.h("kol-button",{exportparts:"icon",_icon:o,_hideLabel:!0,_label:i18n.translate("kol-change-order",{placeholders:{colLabel:n.label}}),_on:{onClick:()=>{if("function"==typeof n.sort){switch(this.sortFunction=n.sort,this.sortDirections.get(this.sortFunction)){case"ASC":this.setSortDirection(this.sortFunction,"DESC");break;case"DESC":this.setSortDirection(this.sortFunction,"NOS");break;default:this.setSortDirection(this.sortFunction,"ASC")}this.updateSortedData(n)}}},_variant:"ghost"})))}return index.h("td",{key:`tbody-${e}-${i}-${t.label}`,class:{[t.textAlign]:"string"==typeof t.textAlign&&t.textAlign.length>0},colSpan:t.colSpan,rowSpan:t.rowSpan,style:{textAlign:t.textAlign,width:t.width},ref:"function"==typeof t.render?e=>{this.cellRender(t,e)}:void 0},"function"!=typeof t.render?t.label:"")},this.renderFoot=()=>{const t=this.createDataField(this.state._dataFoot,this.state._headers,!0);return index.h("tfoot",null,t.map(this.renderTableRow))},this.tableDivElementHasScrollbar=!1,this._caption=void 0,this._data=void 0,this._dataFoot=void 0,this._headers=void 0,this._label=void 0,this._minWidth=void 0,this._pagination=void 0,this.state={_data:[],_dataFoot:[],_headers:{horizontal:[],vertical:[]},_label:"…",_pagination:{_page:1,_pageSize:10,_max:0},_sortedData:[]}}validateCaption(t){this.validateLabel(t)}validateData(t){prop_validators.emptyStringByArrayHandler(t,(()=>{prop_validators.objectObjectHandler(t,(()=>{void 0===t&&(t=[]);try{t=prop_validators.parseJson(t)}catch(t){}Array.isArray(t)&&void 0===t.find((t=>!("object"==typeof t&&null!==t)))&&prop_validators.setState(this,"_data",t,{afterPatch:()=>{setTimeout(this.updateSortedData)}})}))}))}validateDataFoot(t){prop_validators.emptyStringByArrayHandler(t,(()=>{prop_validators.objectObjectHandler(t,(()=>{void 0===t&&(t=[]);try{t=prop_validators.parseJson(t)}catch(t){}Array.isArray(t)&&void 0===t.find((t=>!("object"==typeof t&&null!==t)))&&prop_validators.setState(this,"_dataFoot",t,{afterPatch:()=>{setTimeout(this.updateSortedData)}})}))}))}validateHeaders(t){prop_validators.emptyStringByArrayHandler(t,(()=>{prop_validators.objectObjectHandler(t,(()=>{try{t=prop_validators.parseJson(t)}catch(t){}prop_validators.watchValidator(this,"_headers",(t=>"object"==typeof t&&null!==t),new Set(["KoliBriTableHeaders"]),t,{hooks:{beforePatch:t=>{var e,i,n,a;const o=t=>{t.forEach(((t,e)=>{const i=t.sortDirection;"function"!=typeof t.sort||"ASC"!==i&&"DESC"!==i||(this.setSortDirection(t.sort,i),setTimeout((()=>this.updateSortedData({key:t.key||`cell-${e}`,label:t.label,sortDirection:i}))))}))},s=t;null===(e=s.horizontal)||void 0===e||e.forEach(o),null===(i=s.vertical)||void 0===i||i.forEach(o),s.horizontal&&s.vertical&&(null===(n=s.horizontal)||void 0===n?void 0:n.length)>0&&(null===(a=s.vertical)||void 0===a?void 0:a.length)>0&&(this.disableSort=!0,a11y_tipps.devHint("Table: You can not sort the table data, if horizontal and vertical headers are defined at the same time. (https://github.com/public-ui/kolibri/issues/2372)"))}}})}))}))}validateLabel(t){label.validateLabel(this,t,{required:!0})}validateMinWidth(t){prop_validators.watchString(this,"_minWidth",t,{defaultValue:void 0})}validatePagination(t){try{t=prop_validators.parseJson(t)}catch(t){}this.showPagination=paginationValidator(t),prop_validators.watchValidator(this,"_pagination",paginationValidator,new Set(["boolean","KoliBriTablePagination"]),t,{defaultValue:{_page:1,_pageSize:10,_max:0}})}componentWillLoad(){this.validateData(this._data),this.validateDataFoot(this._dataFoot),this.validateHeaders(this._headers),this.validateLabel(this._label||this._caption),this.validateMinWidth(this._minWidth),this.validatePagination(this._pagination)}componentDidRender(){this.checkDivElementScrollbar()}componentDidLoad(){this.tableDivElement&&ResizeObserver&&(this.tableDivElementResizeObserver=new ResizeObserver(this.checkDivElementScrollbar.bind(this)),this.tableDivElementResizeObserver.observe(this.tableDivElement))}disconnectedCallback(){var t;null===(t=this.tableDivElementResizeObserver)||void 0===t||t.disconnect()}checkDivElementScrollbar(){this.tableDivElement&&(this.tableDivElementHasScrollbar=this.tableDivElement.scrollWidth>this.tableDivElement.clientWidth)}getNumberOfCols(t,e){let i=0;return t.forEach((t=>{let e=0;t.forEach((t=>{var i;return e+=null!==(i=t.colSpan)&&void 0!==i?i:1})),i<e&&(i=e)})),0===i&&(i=e.length),i}getNumberOfRows(t,e){let i=0;return t.forEach((t=>{let e=0;t.forEach((t=>{var i;return e+=null!==(i=t.rowSpan)&&void 0!==i?i:1})),i<e&&(i=e)})),0===i?i=e.length:i-=this.state._dataFoot.length,i}filterHeaderKeys(t){const e=[];return t.forEach((t=>{t.forEach((t=>{"string"==typeof t.key&&e.push(t)}))})),e}getPrimaryHeader(t){var e,i;let n=this.filterHeaderKeys(null!==(e=t.horizontal)&&void 0!==e?e:[]);return this.horizontal=!0,0===n.length&&(n=this.filterHeaderKeys(null!==(i=t.vertical)&&void 0!==i?i:[]),n.length>0&&(this.horizontal=!1)),n}createDataField(t,e,i){e.horizontal=Array.isArray(null==e?void 0:e.horizontal)?e.horizontal:[],e.vertical=Array.isArray(null==e?void 0:e.vertical)?e.vertical:[];const n=this.getPrimaryHeader(e),a=this.getNumberOfCols(e.horizontal,t);let o=this.getNumberOfRows(e.vertical,t),s=0;i&&(s=o,o+=this.state._dataFoot.length);const l=[],r=[],d=[];e.vertical.forEach(((t,e)=>{r[e]=0,d[e]=[]}));for(let h=s;h<o;h++){const o=[];e.vertical.forEach(((t,e)=>{let i=0;if(d[e].forEach((t=>i+=t)),i<=h){const n=t[h-i+r[e]];if("object"==typeof n){o.push(Object.assign(Object.assign({},n),{asTd:!1,data:{}}));let t=1;if("number"==typeof n.rowSpan&&n.rowSpan>1&&(t=n.rowSpan),d[e].push(t),"number"==typeof n.colSpan&&n.colSpan>1)for(let i=1;i<n.colSpan;i++)d[e+i].push(t);r[e]++}}}));for(let e=0;e<a;e++)if(!0===this.horizontal){const a=i?this.state._dataFoot[h-s]:t[h];"object"==typeof n[e]&&null!==n[e]&&"string"==typeof n[e].key&&"object"==typeof a&&null!==a&&o.push(Object.assign(Object.assign({},n[e]),{colSpan:void 0,data:a,label:a[n[e].key],rowSpan:void 0}))}else"object"==typeof n[h]&&null!==n[h]&&"string"==typeof n[h].key&&"object"==typeof t[e]&&null!==t[e]&&o.push(Object.assign(Object.assign({},n[h]),{colSpan:void 0,data:t[e],label:t[e][n[h].key],rowSpan:void 0}));l.push(o)}if(0===t.length){let t=0,i=0;Array.isArray(e.horizontal)&&e.horizontal.length>0&&e.horizontal[0].forEach((e=>{t+=e.colSpan||1})),Array.isArray(e.vertical)&&e.vertical.length>0&&(t-=e.vertical.length,e.vertical[0].forEach((t=>{i+=t.rowSpan||1})));const n={colSpan:t,label:i18n.translate("kol-no-entries"),render:void 0,rowSpan:Math.max(i,1)};0===l.length?l.push([n]):l[0].push(n)}return l}selectDisplayedData(t,e,i){return"number"==typeof e&&e>0&&"number"==typeof i&&i>0?(this.pageStartSlice=e*(i-1),this.pageEndSlice=e*i>t.length?t.length:e*i,t.slice(this.pageStartSlice,this.pageEndSlice)):(this.pageStartSlice=0,this.pageEndSlice=t.length,t)}cellRender(t,e){e&&(clearTimeout(CELL_REFS.get(e)),CELL_REFS.set(e,setTimeout((()=>{clearTimeout(CELL_REFS.get(e));const i=t.render(e,{asTd:t.asTd,label:t.label,textAlign:t.textAlign,width:t.width},t.data,this.state._data);"string"==typeof i&&(e.textContent=i)}))))}render(){var t,e;const i=this.selectDisplayedData(this.state._sortedData,this.showPagination?null!==(e=null===(t=this.state._pagination)||void 0===t?void 0:t._pageSize)&&void 0!==e?e:10:this.state._sortedData.length,this.state._pagination._page||1),n=this.createDataField(i,this.state._headers);return index.h(index.Host,null,this.pageEndSlice>0&&this.showPagination&&index.h("div",{class:"pagination"},index.h("span",null,"Einträge ",this.pageEndSlice>0?this.pageStartSlice+1:0," bis ",this.pageEndSlice," von"," ",this.state._pagination._max||(Array.isArray(this.state._data)?this.state._data.length:0)," angezeigt"),index.h("div",null,index.h("kol-pagination",{_boundaryCount:this.state._pagination._boundaryCount,_customClass:this.state._pagination._customClass,_on:this.handlePagination,_page:this.state._pagination._page,_pageSize:this.state._pagination._pageSize,_pageSizeOptions:this.state._pagination._pageSizeOptions||PAGINATION_OPTIONS,_siblingCount:this.state._pagination._siblingCount,_tooltipAlign:"bottom",_max:this.state._pagination._max||this.state._pagination._total||this.state._data.length,_label:i18n.translate("kol-table-pagination-label",{placeholders:{label:this.state._label}})}))),index.h("div",{ref:t=>this.tableDivElement=t,class:"table",tabindex:"-1",onMouseDown:t=>{t.preventDefault()}},index.h("table",{style:{minWidth:this.state._minWidth}},index.h("caption",{tabindex:this.tableDivElementHasScrollbar?"0":void 0},this.state._label),Array.isArray(this.state._headers.horizontal)&&index.h("thead",null,this.state._headers.horizontal.map(((t,e)=>index.h("tr",{key:`thead-${e}`},t.map(((t,i)=>{if(!0===t.asTd)return index.h("td",{key:`thead-${e}-${i}-${t.label}`,class:{[t.textAlign]:"string"==typeof t.textAlign&&t.textAlign.length>0},colSpan:t.colSpan,rowSpan:t.rowSpan,style:{textAlign:t.textAlign,width:t.width},ref:"function"==typeof t.render?e=>{this.cellRender(t,e)}:void 0},"function"!=typeof t.render?t.label:"");{const n=t;let a,o="codicon codicon-fold";if(n.key===this.sortedColumnHead.key)switch(this.sortedColumnHead.sortDirection){case"ASC":o="codicon codicon-chevron-up",a="ascending";break;case"DESC":o="codicon codicon-chevron-down",a="descending"}return index.h("th",{class:t.textAlign?`align-${t.textAlign}`:void 0,key:`thead-${e}-${i}-${n.label}`,scope:"number"==typeof n.colSpan&&n.colSpan>1?"colgroup":"col",colSpan:n.colSpan,rowSpan:n.rowSpan,style:{width:t.width},"aria-sort":a,"data-sort":a?`sort-${this.sortedColumnHead.sortDirection}`:"sort-NOS"},this.disableSort||"function"!=typeof n.sort?t.label:index.h("kol-button-wc",{class:"table-sort-button",exportparts:"icon",_icons:{right:o},_label:t.label,_on:{onClick:()=>{if("function"==typeof n.sort){switch(this.sortFunction=n.sort,this.sortDirections.get(this.sortFunction)){case"ASC":this.setSortDirection(this.sortFunction,"DESC");break;case"DESC":this.setSortDirection(this.sortFunction,"NOS");break;default:this.setSortDirection(this.sortFunction,"ASC")}this.updateSortedData(n)}}}}))}})))))),index.h("tbody",null,n.map(this.renderTableRow)),this.state._dataFoot.length>0?this.renderFoot():"")))}static get watchers(){return{_caption:["validateCaption"],_data:["validateData"],_dataFoot:["validateDataFoot"],_headers:["validateHeaders"],_label:["validateLabel"],_minWidth:["validateMinWidth"],_pagination:["validatePagination"]}}};KolTable.style={default:KolTableDefaultStyle0},exports.kol_table=KolTable;