/*!
 * KoliBri - The accessible HTML-Standard
 */
import{r as t,h as n,H as e}from"./index-0b7aa54b.js";import{a as i}from"./i18n-e70e3fa4.js";import{v as o}from"./label-00203940.js";import{d as s}from"./a11y.tipps-b5477bd5.js";import{s as a,g as l,d as r,p as h,w as d,o as c}from"./prop.validators-a73a5d11.js";import"./index-6f37dccf.js";import"./index-c88c7ecf.js";import"./dev.utils-232c068c.js";import"./reuse-d79ab469.js";const u="/*\n * This file contains all rules for accessibility.\n */\n:host {\n\t/*\n\t * Minimum size of interactive elements.\n\t */\n\t--a11y-min-size: 44px;\n\t/*\n\t * No element should be used without a background and font color whose contrast ratio has\n\t * not been checked. By initially setting the background color to white and the font color\n\t * to black, the contrast ratio is ensured and explicit adjustment is forced.\n\t */\n\tbackground-color: white;\n\tcolor: black;\n\t/*\n\t * Verdana is an accessible font that can be used without requiring additional loading time.\n\t */\n\tfont-family: Verdana;\n}\n* {\n\t/*\n\t * This rule enables the word dividing for all texts. That is important for high zoom levels.\n\t */\n\thyphens: auto;\n\t/*\n\t * Letter spacing is required for all texts.\n\t */\n\tletter-spacing: inherit;\n\t/*\n\t * This rule enables the word dividing for all texts. That is important for high zoom levels.\n\t */\n\tword-break: break-word;\n\t/*\n\t * Word spacing is required for all texts.\n\t */\n\tword-spacing: inherit;\n}\n/*\n * All interactive elements should have a minimum size of 44px.\n */\n/* input:not([type='checkbox'], [type='radio'], [type='range']), */\n/* option, */\n/* select, */\n/* textarea, */\n[role='button'],\nbutton:not([role='link']),\nkol-input .input {\n\tmin-height: var(--a11y-min-size);\n\tmin-width: var(--a11y-min-size);\n}\n/*\n * Some interactive elements should not inherit the font-family and font-size.\n */\na,\nbutton,\nh1,\nh2,\nh3,\nh4,\nh5,\nh6,\ninput,\noption,\nselect,\ntextarea {\n\t/*\n\t * All elements should inherit the font family from his parent element.\n\t */\n\tfont-family: inherit;\n\t/*\n\t * All elements should inherit the font size from his parent element.\n\t */\n\tfont-size: inherit;\n}\n\n/**\n * Sometimes we need the semantic element for accessibility reasons,\n * but we don't want to show it.\n *\n * - https://www.a11yproject.com/posts/how-to-hide-content/\n */\n.visually-hidden {\n\tclip: rect(0 0 0 0);\n\tclip-path: inset(50%);\n\theight: 1px;\n\toverflow: hidden;\n\tposition: absolute;\n\twhite-space: nowrap;\n\twidth: 1px;\n}\n\n/*\n * Dieses CSS stellt sicher, dass der Standard-Style\n * von A und Button resettet werden.\n */\n:is(a, button) {\n\tbackground-color: transparent;\n\tborder: none;\n\tmargin: 0;\n\tpadding: 0;\n\twidth: 100%; /* 100% needed for custom width from outside */\n}\n\n/*\n\t * Ensure elements with hidden attribute to be actually not visible\n\t * @see https://meowni.ca/hidden.is.a.lie.html\n\t */\n[hidden] {\n\tdisplay: none !important;\n}\n\n:host {\n\t/*\n\t * The max-width is needed to prevent the table from overflowing the\n\t * parent node, if the table is wider than the parent node.\n\t */\n\tmax-width: 100%;\n}\n* {\n\t/*\n\t * We prefer to box-sizing: border-box for all elements.\n\t */\n\tbox-sizing: border-box;\n}\n/* KolSpan is a layout component with icons in all directions and a label text in the middle. */\nkol-span-wc {\n\tdisplay: grid;\n\tplace-items: center;\n}\n/* The sub span in KolSpan is the horizontal span with icon left and right and the label text in the middle. */\nkol-span-wc > span {\n\tdisplay: flex;\n\tplace-items: center;\n}\na,\nbutton {\n\tcursor: pointer;\n}\n/* This is the text label. */\n.icon-only > kol-span-wc > span > span {\n\tdisplay: none;\n}\n.hidden {\n\tdisplay: none;\n\tvisibility: hidden;\n}\n\n:host {\n\tdisplay: block;\n}\n\n:host {\n\tdisplay: grid;\n}\n:host > div.table {\n\tmax-width: 100%;\n\torder: 1;\n\toverflow-x: auto;\n\toverflow-y: hidden;\n}\n:host > div.table table {\n\twidth: 100%;\n}\ncaption {\n\ttext-align: start;\n\n\t&:focus {\n\t\toutline: 0 !important;\n\t}\n}\n.table:has(caption:focus) {\n\t/* @see https://remysharp.com/til/css/focus-ring-default-styles */\n\toutline: 5px auto Highlight;\n\toutline: 5px auto -webkit-focus-ring-color;\n\toutline-offset: 2px;\n}\nth > div {\n\tdisplay: grid;\n\tgrid-template-columns: 1fr auto;\n\tplace-items: center;\n}\n.table-sort-button .button {\n\tcolor: inherit;\n}\nth.align-left {\n\ttext-align: left;\n\t& .table-sort-button .button-inner {\n\t\tjustify-items: start;\n\t}\n}\nth.align-center {\n\ttext-align: center;\n\t& .table-sort-button .button-inner {\n\t\tjustify-items: center;\n\t}\n}\nth.align-right {\n\ttext-align: right;\n\t& .table-sort-button .button-inner {\n\t\tjustify-items: end;\n\t}\n}\ndiv.pagination {\n\torder: 2;\n}\ndiv.pagination,\ndiv.pagination > div:last-child {\n\tdisplay: grid;\n\tplace-items: center;\n}\n@media (min-width: 1024px) {\n\tdiv.pagination,\n\tdiv.pagination > div:last-child {\n\t\tgrid-auto-flow: column;\n\t}\n\tdiv.pagination kol-pagination {\n\t\tdisplay: flex;\n\t}\n}\n",f=u,p=[10,20,50,100],b=new Map,y=t=>!0===t||""===t||"object"==typeof t&&null!==t,g=class{constructor(e){t(this,e),this.horizontal=!0,this.sortDirections=new Map,this.showPagination=!1,this.pageStartSlice=0,this.pageEndSlice=10,this.disableSort=!1,this.sortedColumnHead={label:"",key:"",sortDirection:"NOS"},this.setSortDirection=(t,e)=>{this.sortDirections.clear(),this.sortDirections.set(t,e),this.sortFunction=t},this.handlePagination={onClick:(t,e)=>{var n;"function"==typeof(null===(n=this.state._pagination._on)||void 0===n?void 0:n.onClick)&&this.state._pagination._on.onClick(t,e),a(this,"_pagination",Object.assign(Object.assign({},this.state._pagination),{_page:e}))},onChangePage:(t,e)=>{var n;"function"==typeof(null===(n=this.state._pagination._on)||void 0===n?void 0:n.onChangePage)&&this.state._pagination._on.onChangePage(t,e),a(this,"_pagination",Object.assign(Object.assign({},this.state._pagination),{_page:e}))},onChangePageSize:(t,e)=>{var n;"function"==typeof(null===(n=this.state._pagination._on)||void 0===n?void 0:n.onChangePageSize)&&this.state._pagination._on.onChangePageSize(t,e),a(this,"_pagination",Object.assign(Object.assign({},this.state._pagination),{_pageSize:e})),a(this,"_pageSize",e)}},this.updateSortedData=(t=this.sortedColumnHead)=>{let e=this.state._data;if("function"==typeof this.sortFunction)switch(this.sortDirections.get(this.sortFunction)){case"ASC":e=this.sortFunction([...this.state._data]),this.sortedColumnHead={label:t.label,key:t.key,sortDirection:"ASC"};break;case"DESC":e=this.sortFunction([...this.state._data]).reverse(),this.sortedColumnHead={label:t.label,key:t.key,sortDirection:"DESC"};break;default:e=[...this.state._data],this.sortedColumnHead={label:"",key:"",sortDirection:"NOS"}}a(this,"_sortedData",e)},this.renderTableRow=(t,e)=>n("tr",{key:`tbody-${e}`},t.map(((t,n)=>this.renderTableCell(t,e,n)))),this.renderTableCell=(t,e,a)=>{if(!1===t.asTd){const o=t;let s,l="codicon codicon-fold";if(!this.disableSort&&o.key===this.sortedColumnHead.key)switch(this.sortedColumnHead.sortDirection){case"ASC":l="codicon codicon-chevron-up",s="ascending";break;case"DESC":l="codicon codicon-chevron-down",s="descending"}return n("th",{key:`tbody-${e}-${a}-${o.label}`,scope:"number"==typeof o.rowSpan&&o.rowSpan>1?"rowgroup":"row",colSpan:o.colSpan,rowSpan:o.rowSpan,style:{textAlign:o.textAlign,width:o.width},"aria-sort":s,"data-sort":`sort-${this.sortDirections.get(o.sort)}`},n("div",{class:"w-full flex gap-1 items-center"},n("div",{class:{"w-full":!0,[o.textAlign]:"string"==typeof o.textAlign&&o.textAlign.length>0},style:{textAlign:o.textAlign}},o.label),!this.disableSort&&"function"==typeof o.sort&&n("kol-button",{exportparts:"icon",_icon:l,_hideLabel:!0,_label:i("kol-change-order",{placeholders:{colLabel:o.label}}),_on:{onClick:()=>{if("function"==typeof o.sort){switch(this.sortFunction=o.sort,this.sortDirections.get(this.sortFunction)){case"ASC":this.setSortDirection(this.sortFunction,"DESC");break;case"DESC":this.setSortDirection(this.sortFunction,"NOS");break;default:this.setSortDirection(this.sortFunction,"ASC")}this.updateSortedData(o)}}},_variant:"ghost"})))}return n("td",{key:`tbody-${e}-${a}-${t.label}`,class:{[t.textAlign]:"string"==typeof t.textAlign&&t.textAlign.length>0},colSpan:t.colSpan,rowSpan:t.rowSpan,style:{textAlign:t.textAlign,width:t.width},ref:"function"==typeof t.render?e=>{this.cellRender(t,e)}:void 0},"function"!=typeof t.render?t.label:"")},this.renderFoot=()=>{const t=this.createDataField(this.state._dataFoot,this.state._headers,!0);return n("tfoot",null,t.map(this.renderTableRow))},this.tableDivElementHasScrollbar=!1,this._caption=void 0,this._data=void 0,this._dataFoot=void 0,this._headers=void 0,this._label=void 0,this._minWidth=void 0,this._pagination=void 0,this.state={_data:[],_dataFoot:[],_headers:{horizontal:[],vertical:[]},_label:"…",_pagination:{_page:1,_pageSize:10,_max:0},_sortedData:[]}}validateCaption(t){this.validateLabel(t)}validateData(t){l(t,(()=>{c(t,(()=>{void 0===t&&(t=[]);try{t=h(t)}catch(t){}Array.isArray(t)&&void 0===t.find((t=>!("object"==typeof t&&null!==t)))&&a(this,"_data",t,{afterPatch:()=>{setTimeout(this.updateSortedData)}})}))}))}validateDataFoot(t){l(t,(()=>{c(t,(()=>{void 0===t&&(t=[]);try{t=h(t)}catch(t){}Array.isArray(t)&&void 0===t.find((t=>!("object"==typeof t&&null!==t)))&&a(this,"_dataFoot",t,{afterPatch:()=>{setTimeout(this.updateSortedData)}})}))}))}validateHeaders(t){l(t,(()=>{c(t,(()=>{try{t=h(t)}catch(t){}d(this,"_headers",(t=>"object"==typeof t&&null!==t),new Set(["KoliBriTableHeaders"]),t,{hooks:{beforePatch:t=>{var e,n,i,a;const o=t=>{t.forEach(((t,e)=>{const n=t.sortDirection;"function"!=typeof t.sort||"ASC"!==n&&"DESC"!==n||(this.setSortDirection(t.sort,n),setTimeout((()=>this.updateSortedData({key:t.key||`cell-${e}`,label:t.label,sortDirection:n}))))}))},l=t;null===(e=l.horizontal)||void 0===e||e.forEach(o),null===(n=l.vertical)||void 0===n||n.forEach(o),l.horizontal&&l.vertical&&(null===(i=l.horizontal)||void 0===i?void 0:i.length)>0&&(null===(a=l.vertical)||void 0===a?void 0:a.length)>0&&(this.disableSort=!0,s("Table: You can not sort the table data, if horizontal and vertical headers are defined at the same time. (https://github.com/public-ui/kolibri/issues/2372)"))}}})}))}))}validateLabel(t){o(this,t,{required:!0})}validateMinWidth(t){r(this,"_minWidth",t,{defaultValue:void 0})}validatePagination(t){try{t=h(t)}catch(t){}this.showPagination=y(t),d(this,"_pagination",y,new Set(["boolean","KoliBriTablePagination"]),t,{defaultValue:{_page:1,_pageSize:10,_max:0}})}componentWillLoad(){this.validateData(this._data),this.validateDataFoot(this._dataFoot),this.validateHeaders(this._headers),this.validateLabel(this._label||this._caption),this.validateMinWidth(this._minWidth),this.validatePagination(this._pagination)}componentDidRender(){this.checkDivElementScrollbar()}componentDidLoad(){this.tableDivElement&&ResizeObserver&&(this.tableDivElementResizeObserver=new ResizeObserver(this.checkDivElementScrollbar.bind(this)),this.tableDivElementResizeObserver.observe(this.tableDivElement))}disconnectedCallback(){var t;null===(t=this.tableDivElementResizeObserver)||void 0===t||t.disconnect()}checkDivElementScrollbar(){this.tableDivElement&&(this.tableDivElementHasScrollbar=this.tableDivElement.scrollWidth>this.tableDivElement.clientWidth)}getNumberOfCols(t,e){let n=0;return t.forEach((t=>{let e=0;t.forEach((t=>{var n;return e+=null!==(n=t.colSpan)&&void 0!==n?n:1})),n<e&&(n=e)})),0===n&&(n=e.length),n}getNumberOfRows(t,e){let n=0;return t.forEach((t=>{let e=0;t.forEach((t=>{var n;return e+=null!==(n=t.rowSpan)&&void 0!==n?n:1})),n<e&&(n=e)})),0===n?n=e.length:n-=this.state._dataFoot.length,n}filterHeaderKeys(t){const e=[];return t.forEach((t=>{t.forEach((t=>{"string"==typeof t.key&&e.push(t)}))})),e}getPrimaryHeader(t){var e,n;let i=this.filterHeaderKeys(null!==(e=t.horizontal)&&void 0!==e?e:[]);return this.horizontal=!0,0===i.length&&(i=this.filterHeaderKeys(null!==(n=t.vertical)&&void 0!==n?n:[]),i.length>0&&(this.horizontal=!1)),i}createDataField(t,e,n){e.horizontal=Array.isArray(null==e?void 0:e.horizontal)?e.horizontal:[],e.vertical=Array.isArray(null==e?void 0:e.vertical)?e.vertical:[];const a=this.getPrimaryHeader(e),o=this.getNumberOfCols(e.horizontal,t);let s=this.getNumberOfRows(e.vertical,t),l=0;n&&(l=s,s+=this.state._dataFoot.length);const r=[],h=[],d=[];e.vertical.forEach(((t,e)=>{h[e]=0,d[e]=[]}));for(let i=l;i<s;i++){const s=[];e.vertical.forEach(((t,e)=>{let n=0;if(d[e].forEach((t=>n+=t)),n<=i){const a=t[i-n+h[e]];if("object"==typeof a){s.push(Object.assign(Object.assign({},a),{asTd:!1,data:{}}));let t=1;if("number"==typeof a.rowSpan&&a.rowSpan>1&&(t=a.rowSpan),d[e].push(t),"number"==typeof a.colSpan&&a.colSpan>1)for(let n=1;n<a.colSpan;n++)d[e+n].push(t);h[e]++}}}));for(let e=0;e<o;e++)if(!0===this.horizontal){const o=n?this.state._dataFoot[i-l]:t[i];"object"==typeof a[e]&&null!==a[e]&&"string"==typeof a[e].key&&"object"==typeof o&&null!==o&&s.push(Object.assign(Object.assign({},a[e]),{colSpan:void 0,data:o,label:o[a[e].key],rowSpan:void 0}))}else"object"==typeof a[i]&&null!==a[i]&&"string"==typeof a[i].key&&"object"==typeof t[e]&&null!==t[e]&&s.push(Object.assign(Object.assign({},a[i]),{colSpan:void 0,data:t[e],label:t[e][a[i].key],rowSpan:void 0}));r.push(s)}if(0===t.length){let t=0,n=0;Array.isArray(e.horizontal)&&e.horizontal.length>0&&e.horizontal[0].forEach((e=>{t+=e.colSpan||1})),Array.isArray(e.vertical)&&e.vertical.length>0&&(t-=e.vertical.length,e.vertical[0].forEach((t=>{n+=t.rowSpan||1})));const a={colSpan:t,label:i("kol-no-entries"),render:void 0,rowSpan:Math.max(n,1)};0===r.length?r.push([a]):r[0].push(a)}return r}selectDisplayedData(t,e,n){return"number"==typeof e&&e>0&&"number"==typeof n&&n>0?(this.pageStartSlice=e*(n-1),this.pageEndSlice=e*n>t.length?t.length:e*n,t.slice(this.pageStartSlice,this.pageEndSlice)):(this.pageStartSlice=0,this.pageEndSlice=t.length,t)}cellRender(t,e){e&&(clearTimeout(b.get(e)),b.set(e,setTimeout((()=>{clearTimeout(b.get(e));const n=t.render(e,{asTd:t.asTd,label:t.label,textAlign:t.textAlign,width:t.width},t.data,this.state._data);"string"==typeof n&&(e.textContent=n)}))))}render(){var t,a;const o=this.selectDisplayedData(this.state._sortedData,this.showPagination?null!==(a=null===(t=this.state._pagination)||void 0===t?void 0:t._pageSize)&&void 0!==a?a:10:this.state._sortedData.length,this.state._pagination._page||1),s=this.createDataField(o,this.state._headers);return n(e,null,this.pageEndSlice>0&&this.showPagination&&n("div",{class:"pagination"},n("span",null,"Einträge ",this.pageEndSlice>0?this.pageStartSlice+1:0," bis ",this.pageEndSlice," von"," ",this.state._pagination._max||(Array.isArray(this.state._data)?this.state._data.length:0)," angezeigt"),n("div",null,n("kol-pagination",{_boundaryCount:this.state._pagination._boundaryCount,_customClass:this.state._pagination._customClass,_on:this.handlePagination,_page:this.state._pagination._page,_pageSize:this.state._pagination._pageSize,_pageSizeOptions:this.state._pagination._pageSizeOptions||p,_siblingCount:this.state._pagination._siblingCount,_tooltipAlign:"bottom",_max:this.state._pagination._max||this.state._pagination._total||this.state._data.length,_label:i("kol-table-pagination-label",{placeholders:{label:this.state._label}})}))),n("div",{ref:t=>this.tableDivElement=t,class:"table",tabindex:"-1",onMouseDown:t=>{t.preventDefault()}},n("table",{style:{minWidth:this.state._minWidth}},n("caption",{tabindex:this.tableDivElementHasScrollbar?"0":void 0},this.state._label),Array.isArray(this.state._headers.horizontal)&&n("thead",null,this.state._headers.horizontal.map(((t,e)=>n("tr",{key:`thead-${e}`},t.map(((t,i)=>{if(!0===t.asTd)return n("td",{key:`thead-${e}-${i}-${t.label}`,class:{[t.textAlign]:"string"==typeof t.textAlign&&t.textAlign.length>0},colSpan:t.colSpan,rowSpan:t.rowSpan,style:{textAlign:t.textAlign,width:t.width},ref:"function"==typeof t.render?e=>{this.cellRender(t,e)}:void 0},"function"!=typeof t.render?t.label:"");{const a=t;let o,s="codicon codicon-fold";if(a.key===this.sortedColumnHead.key)switch(this.sortedColumnHead.sortDirection){case"ASC":s="codicon codicon-chevron-up",o="ascending";break;case"DESC":s="codicon codicon-chevron-down",o="descending"}return n("th",{class:t.textAlign?`align-${t.textAlign}`:void 0,key:`thead-${e}-${i}-${a.label}`,scope:"number"==typeof a.colSpan&&a.colSpan>1?"colgroup":"col",colSpan:a.colSpan,rowSpan:a.rowSpan,style:{width:t.width},"aria-sort":o,"data-sort":o?`sort-${this.sortedColumnHead.sortDirection}`:"sort-NOS"},this.disableSort||"function"!=typeof a.sort?t.label:n("kol-button-wc",{class:"table-sort-button",exportparts:"icon",_icons:{right:s},_label:t.label,_on:{onClick:()=>{if("function"==typeof a.sort){switch(this.sortFunction=a.sort,this.sortDirections.get(this.sortFunction)){case"ASC":this.setSortDirection(this.sortFunction,"DESC");break;case"DESC":this.setSortDirection(this.sortFunction,"NOS");break;default:this.setSortDirection(this.sortFunction,"ASC")}this.updateSortedData(a)}}}}))}})))))),n("tbody",null,s.map(this.renderTableRow)),this.state._dataFoot.length>0?this.renderFoot():"")))}static get watchers(){return{_caption:["validateCaption"],_data:["validateData"],_dataFoot:["validateDataFoot"],_headers:["validateHeaders"],_label:["validateLabel"],_minWidth:["validateMinWidth"],_pagination:["validatePagination"]}}};g.style={default:f};export{g as kol_table};